/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSAllVideoCapabilities_h
#define JSAllVideoCapabilities_h

#if ENABLE(MEDIA_STREAM)

#include "AllVideoCapabilities.h"
#include "JSMediaStreamCapabilities.h"
#include <runtime/JSObject.h>

namespace WebCore {

class JSAllVideoCapabilities : public JSMediaStreamCapabilities {
public:
    typedef JSMediaStreamCapabilities Base;
    static JSAllVideoCapabilities* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<AllVideoCapabilities> impl)
    {
        JSAllVideoCapabilities* ptr = new (NotNull, JSC::allocateCell<JSAllVideoCapabilities>(globalObject->vm().heap)) JSAllVideoCapabilities(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    AllVideoCapabilities& impl() const
    {
        return static_cast<AllVideoCapabilities&>(Base::impl());
    }
protected:
    JSAllVideoCapabilities(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<AllVideoCapabilities>);
    void finishCreation(JSC::VM&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::InterceptsGetOwnPropertySlotByIndexEvenWhenLengthIsNotZero | Base::StructureFlags;
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, AllVideoCapabilities*);

class JSAllVideoCapabilitiesPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::VM&, JSC::JSGlobalObject*);
    static JSAllVideoCapabilitiesPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAllVideoCapabilitiesPrototype* ptr = new (NotNull, JSC::allocateCell<JSAllVideoCapabilitiesPrototype>(vm.heap)) JSAllVideoCapabilitiesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAllVideoCapabilitiesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(vm, structure) { }
protected:
    static const unsigned StructureFlags = Base::StructureFlags;
};

// Attributes

JSC::JSValue jsAllVideoCapabilitiesSourceType(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesSourceId(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesWidth(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesHeight(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesFrameRate(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesAspectRatio(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsAllVideoCapabilitiesFacingMode(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)

#endif
