/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(INDEXED_DATABASE)

#include "JSIDBVersionChangeEvent.h"

#include "IDBVersionChangeEvent.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSIDBVersionChangeEventTableValues[] =
{
    { "oldVersion", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIDBVersionChangeEventOldVersion), (intptr_t)0 },
    { "newVersion", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIDBVersionChangeEventNewVersion), (intptr_t)0 },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIDBVersionChangeEventConstructor), (intptr_t)0 },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSIDBVersionChangeEventTable = { 8, 7, JSIDBVersionChangeEventTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSIDBVersionChangeEventConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSIDBVersionChangeEventConstructorTable = { 1, 0, JSIDBVersionChangeEventConstructorTableValues, 0 };
static const HashTable& getJSIDBVersionChangeEventConstructorTable(ExecState* exec)
{
    return getHashTableForGlobalData(exec->vm(), JSIDBVersionChangeEventConstructorTable);
}

const ClassInfo JSIDBVersionChangeEventConstructor::s_info = { "IDBVersionChangeEventConstructor", &Base::s_info, 0, getJSIDBVersionChangeEventConstructorTable, CREATE_METHOD_TABLE(JSIDBVersionChangeEventConstructor) };

JSIDBVersionChangeEventConstructor::JSIDBVersionChangeEventConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSIDBVersionChangeEventConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSIDBVersionChangeEventPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSIDBVersionChangeEventConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSIDBVersionChangeEventConstructor, JSDOMWrapper>(exec, getJSIDBVersionChangeEventConstructorTable(exec), jsCast<JSIDBVersionChangeEventConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSIDBVersionChangeEventPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSIDBVersionChangeEventPrototypeTable = { 1, 0, JSIDBVersionChangeEventPrototypeTableValues, 0 };
static const HashTable& getJSIDBVersionChangeEventPrototypeTable(ExecState* exec)
{
    return getHashTableForGlobalData(exec->vm(), JSIDBVersionChangeEventPrototypeTable);
}

const ClassInfo JSIDBVersionChangeEventPrototype::s_info = { "IDBVersionChangeEventPrototype", &Base::s_info, 0, getJSIDBVersionChangeEventPrototypeTable, CREATE_METHOD_TABLE(JSIDBVersionChangeEventPrototype) };

JSObject* JSIDBVersionChangeEventPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSIDBVersionChangeEvent>(vm, globalObject);
}

static const HashTable& getJSIDBVersionChangeEventTable(ExecState* exec)
{
    return getHashTableForGlobalData(exec->vm(), JSIDBVersionChangeEventTable);
}

const ClassInfo JSIDBVersionChangeEvent::s_info = { "IDBVersionChangeEvent", &Base::s_info, 0, getJSIDBVersionChangeEventTable , CREATE_METHOD_TABLE(JSIDBVersionChangeEvent) };

JSIDBVersionChangeEvent::JSIDBVersionChangeEvent(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<IDBVersionChangeEvent> impl)
    : JSEvent(structure, globalObject, impl)
{
}

void JSIDBVersionChangeEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSIDBVersionChangeEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSIDBVersionChangeEventPrototype::create(vm, globalObject, JSIDBVersionChangeEventPrototype::createStructure(vm, globalObject, JSEventPrototype::self(vm, globalObject)));
}

bool JSIDBVersionChangeEvent::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSIDBVersionChangeEvent* thisObject = jsCast<JSIDBVersionChangeEvent*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSIDBVersionChangeEvent, Base>(exec, getJSIDBVersionChangeEventTable(exec), thisObject, propertyName, slot);
}

JSValue jsIDBVersionChangeEventOldVersion(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSIDBVersionChangeEvent* castedThis = jsCast<JSIDBVersionChangeEvent*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    IDBVersionChangeEvent& impl = castedThis->impl();
    JSValue result = jsNumber(impl.oldVersion());
    return result;
}


JSValue jsIDBVersionChangeEventNewVersion(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSIDBVersionChangeEvent* castedThis = jsCast<JSIDBVersionChangeEvent*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    bool isNull = false;
    IDBVersionChangeEvent& impl = castedThis->impl();
    JSValue result = jsNumber(impl.newVersion(isNull));
    if (isNull)
        return jsNull();
    return result;
}


JSValue jsIDBVersionChangeEventConstructor(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSIDBVersionChangeEvent* domObject = jsCast<JSIDBVersionChangeEvent*>(asObject(slotBase));
    return JSIDBVersionChangeEvent::getConstructor(exec->vm(), domObject->globalObject());
}

JSValue JSIDBVersionChangeEvent::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSIDBVersionChangeEventConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}

#endif // ENABLE(INDEXED_DATABASE)
