/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(JAVASCRIPT_DEBUGGER)

#include "JSJavaScriptCallFrame.h"

#include "JSJavaScriptCallFrame.h"
#include "JavaScriptCallFrame.h"
#include "URL.h"
#include <runtime/Error.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSJavaScriptCallFrameTableValues[] =
{
    { "caller", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameCaller), (intptr_t)0 },
    { "sourceID", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameSourceID), (intptr_t)0 },
    { "line", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameLine), (intptr_t)0 },
    { "column", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameColumn), (intptr_t)0 },
    { "scopeChain", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameScopeChain), (intptr_t)0 },
    { "thisObject", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameThisObject), (intptr_t)0 },
    { "functionName", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameFunctionName), (intptr_t)0 },
    { "type", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameType), (intptr_t)0 },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSJavaScriptCallFrameTable = { 17, 15, JSJavaScriptCallFrameTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSJavaScriptCallFramePrototypeTableValues[] =
{
    { "GLOBAL_SCOPE", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameGLOBAL_SCOPE), (intptr_t)0 },
    { "LOCAL_SCOPE", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameLOCAL_SCOPE), (intptr_t)0 },
    { "WITH_SCOPE", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameWITH_SCOPE), (intptr_t)0 },
    { "CLOSURE_SCOPE", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameCLOSURE_SCOPE), (intptr_t)0 },
    { "CATCH_SCOPE", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsJavaScriptCallFrameCATCH_SCOPE), (intptr_t)0 },
    { "evaluate", DontDelete | JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsJavaScriptCallFramePrototypeFunctionEvaluate), (intptr_t)1 },
    { "scopeType", DontDelete | JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsJavaScriptCallFramePrototypeFunctionScopeType), (intptr_t)1 },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSJavaScriptCallFramePrototypeTable = { 17, 15, JSJavaScriptCallFramePrototypeTableValues, 0 };
const ClassInfo JSJavaScriptCallFramePrototype::s_info = { "JavaScriptCallFramePrototype", &Base::s_info, &JSJavaScriptCallFramePrototypeTable, 0, CREATE_METHOD_TABLE(JSJavaScriptCallFramePrototype) };

JSObject* JSJavaScriptCallFramePrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSJavaScriptCallFrame>(vm, globalObject);
}

bool JSJavaScriptCallFramePrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSJavaScriptCallFramePrototype* thisObject = jsCast<JSJavaScriptCallFramePrototype*>(object);
    return getStaticPropertySlot<JSJavaScriptCallFramePrototype, JSObject>(exec, JSJavaScriptCallFramePrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSJavaScriptCallFrame::s_info = { "JavaScriptCallFrame", &Base::s_info, &JSJavaScriptCallFrameTable, 0 , CREATE_METHOD_TABLE(JSJavaScriptCallFrame) };

JSJavaScriptCallFrame::JSJavaScriptCallFrame(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<JavaScriptCallFrame> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSJavaScriptCallFrame::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSJavaScriptCallFrame::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSJavaScriptCallFramePrototype::create(vm, globalObject, JSJavaScriptCallFramePrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSJavaScriptCallFrame::destroy(JSC::JSCell* cell)
{
    JSJavaScriptCallFrame* thisObject = static_cast<JSJavaScriptCallFrame*>(cell);
    thisObject->JSJavaScriptCallFrame::~JSJavaScriptCallFrame();
}

JSJavaScriptCallFrame::~JSJavaScriptCallFrame()
{
    releaseImplIfNotNull();
}

bool JSJavaScriptCallFrame::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSJavaScriptCallFrame* thisObject = jsCast<JSJavaScriptCallFrame*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSJavaScriptCallFrame, Base>(exec, JSJavaScriptCallFrameTable, thisObject, propertyName, slot);
}

JSValue jsJavaScriptCallFrameCaller(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    JavaScriptCallFrame& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.caller()));
    return result;
}


JSValue jsJavaScriptCallFrameSourceID(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    JavaScriptCallFrame& impl = castedThis->impl();
    JSValue result = jsNumber(impl.sourceID());
    return result;
}


JSValue jsJavaScriptCallFrameLine(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    JavaScriptCallFrame& impl = castedThis->impl();
    JSValue result = jsNumber(impl.line());
    return result;
}


JSValue jsJavaScriptCallFrameColumn(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    JavaScriptCallFrame& impl = castedThis->impl();
    JSValue result = jsNumber(impl.column());
    return result;
}


JSValue jsJavaScriptCallFrameScopeChain(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    return castedThis->scopeChain(exec);
}


JSValue jsJavaScriptCallFrameThisObject(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    return castedThis->thisObject(exec);
}


JSValue jsJavaScriptCallFrameFunctionName(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    JavaScriptCallFrame& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.functionName());
    return result;
}


JSValue jsJavaScriptCallFrameType(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(slotBase));
    return castedThis->type(exec);
}


EncodedJSValue JSC_HOST_CALL jsJavaScriptCallFramePrototypeFunctionEvaluate(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    if (!thisValue.inherits(JSJavaScriptCallFrame::info()))
        return throwVMTypeError(exec);
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(thisValue));
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSJavaScriptCallFrame::info());
    return JSValue::encode(castedThis->evaluate(exec));
}

EncodedJSValue JSC_HOST_CALL jsJavaScriptCallFramePrototypeFunctionScopeType(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    if (!thisValue.inherits(JSJavaScriptCallFrame::info()))
        return throwVMTypeError(exec);
    JSJavaScriptCallFrame* castedThis = jsCast<JSJavaScriptCallFrame*>(asObject(thisValue));
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSJavaScriptCallFrame::info());
    return JSValue::encode(castedThis->scopeType(exec));
}

// Constant getters

JSValue jsJavaScriptCallFrameGLOBAL_SCOPE(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(0));
}

JSValue jsJavaScriptCallFrameLOCAL_SCOPE(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(1));
}

JSValue jsJavaScriptCallFrameWITH_SCOPE(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(2));
}

JSValue jsJavaScriptCallFrameCLOSURE_SCOPE(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(3));
}

JSValue jsJavaScriptCallFrameCATCH_SCOPE(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(4));
}

static inline bool isObservable(JSJavaScriptCallFrame* jsJavaScriptCallFrame)
{
    if (jsJavaScriptCallFrame->hasCustomProperties())
        return true;
    return false;
}

bool JSJavaScriptCallFrameOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSJavaScriptCallFrame* jsJavaScriptCallFrame = jsCast<JSJavaScriptCallFrame*>(handle.get().asCell());
    if (!isObservable(jsJavaScriptCallFrame))
        return false;
    UNUSED_PARAM(visitor);
    return false;
}

void JSJavaScriptCallFrameOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSJavaScriptCallFrame* jsJavaScriptCallFrame = jsCast<JSJavaScriptCallFrame*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsJavaScriptCallFrame->impl(), jsJavaScriptCallFrame);
    jsJavaScriptCallFrame->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, JavaScriptCallFrame* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSJavaScriptCallFrame>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to JavaScriptCallFrame.
    COMPILE_ASSERT(!__is_polymorphic(JavaScriptCallFrame), JavaScriptCallFrame_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<JavaScriptCallFrame>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSJavaScriptCallFrame>(exec, globalObject, impl);
}

JavaScriptCallFrame* toJavaScriptCallFrame(JSC::JSValue value)
{
    return value.inherits(JSJavaScriptCallFrame::info()) ? &jsCast<JSJavaScriptCallFrame*>(asObject(value))->impl() : 0;
}

}

#endif // ENABLE(JAVASCRIPT_DEBUGGER)
