/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSMediaSourceStates_h
#define JSMediaSourceStates_h

#if ENABLE(MEDIA_STREAM)

#include "JSDOMBinding.h"
#include "MediaSourceStates.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class JSMediaSourceStates : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSMediaSourceStates* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<MediaSourceStates> impl)
    {
        JSMediaSourceStates* ptr = new (NotNull, JSC::allocateCell<JSMediaSourceStates>(globalObject->vm().heap)) JSMediaSourceStates(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static void destroy(JSC::JSCell*);
    ~JSMediaSourceStates();
    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom attributes
    JSC::JSValue width(JSC::ExecState*) const;
    JSC::JSValue height(JSC::ExecState*) const;
    JSC::JSValue frameRate(JSC::ExecState*) const;
    JSC::JSValue aspectRatio(JSC::ExecState*) const;
    JSC::JSValue facingMode(JSC::ExecState*) const;
    JSC::JSValue volume(JSC::ExecState*) const;
    MediaSourceStates& impl() const { return *m_impl; }
    void releaseImpl() { m_impl->deref(); m_impl = 0; }

    void releaseImplIfNotNull()
    {
        if (m_impl) {
            m_impl->deref();
            m_impl = 0;
        }
    }

private:
    MediaSourceStates* m_impl;
protected:
    JSMediaSourceStates(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<MediaSourceStates>);
    void finishCreation(JSC::VM&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::InterceptsGetOwnPropertySlotByIndexEvenWhenLengthIsNotZero | Base::StructureFlags;
};

class JSMediaSourceStatesOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, MediaSourceStates*)
{
    DEFINE_STATIC_LOCAL(JSMediaSourceStatesOwner, jsMediaSourceStatesOwner, ());
    return &jsMediaSourceStatesOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, MediaSourceStates*)
{
    return &world;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, MediaSourceStates*);
MediaSourceStates* toMediaSourceStates(JSC::JSValue);

class JSMediaSourceStatesPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::VM&, JSC::JSGlobalObject*);
    static JSMediaSourceStatesPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaSourceStatesPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaSourceStatesPrototype>(vm.heap)) JSMediaSourceStatesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaSourceStatesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(vm, structure) { }
protected:
    static const unsigned StructureFlags = Base::StructureFlags;
};

// Attributes

JSC::JSValue jsMediaSourceStatesSourceType(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesSourceId(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesWidth(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesHeight(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesFrameRate(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesAspectRatio(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesFacingMode(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsMediaSourceStatesVolume(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)

#endif
