/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSRTCDataChannel_h
#define JSRTCDataChannel_h

#if ENABLE(MEDIA_STREAM)

#include "JSDOMBinding.h"
#include "RTCDataChannel.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class JSRTCDataChannel : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSRTCDataChannel* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<RTCDataChannel> impl)
    {
        JSRTCDataChannel* ptr = new (NotNull, JSC::allocateCell<JSRTCDataChannel>(globalObject->vm().heap)) JSRTCDataChannel(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static void put(JSC::JSCell*, JSC::ExecState*, JSC::PropertyName, JSC::JSValue, JSC::PutPropertySlot&);
    static void destroy(JSC::JSCell*);
    ~JSRTCDataChannel();
    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static void visitChildren(JSCell*, JSC::SlotVisitor&);

    RTCDataChannel& impl() const { return *m_impl; }
    void releaseImpl() { m_impl->deref(); m_impl = 0; }

    void releaseImplIfNotNull()
    {
        if (m_impl) {
            m_impl->deref();
            m_impl = 0;
        }
    }

private:
    RTCDataChannel* m_impl;
protected:
    JSRTCDataChannel(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<RTCDataChannel>);
    void finishCreation(JSC::VM&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::InterceptsGetOwnPropertySlotByIndexEvenWhenLengthIsNotZero | JSC::OverridesVisitChildren | Base::StructureFlags;
};

class JSRTCDataChannelOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, RTCDataChannel*)
{
    DEFINE_STATIC_LOCAL(JSRTCDataChannelOwner, jsRTCDataChannelOwner, ());
    return &jsRTCDataChannelOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, RTCDataChannel*)
{
    return &world;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, RTCDataChannel*);
RTCDataChannel* toRTCDataChannel(JSC::JSValue);

class JSRTCDataChannelPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::VM&, JSC::JSGlobalObject*);
    static JSRTCDataChannelPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSRTCDataChannelPrototype* ptr = new (NotNull, JSC::allocateCell<JSRTCDataChannelPrototype>(vm.heap)) JSRTCDataChannelPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSRTCDataChannelPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(vm, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::OverridesVisitChildren | Base::StructureFlags;
};

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsRTCDataChannelPrototypeFunctionSend(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsRTCDataChannelPrototypeFunctionClose(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsRTCDataChannelPrototypeFunctionAddEventListener(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsRTCDataChannelPrototypeFunctionRemoveEventListener(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsRTCDataChannelPrototypeFunctionDispatchEvent(JSC::ExecState*);
// Attributes

JSC::JSValue jsRTCDataChannelLabel(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelOrdered(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelMaxRetransmitTime(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelMaxRetransmits(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelProtocol(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelNegotiated(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelId(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelReadyState(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelBufferedAmount(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsRTCDataChannelBinaryType(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSRTCDataChannelBinaryType(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsRTCDataChannelOnopen(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSRTCDataChannelOnopen(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsRTCDataChannelOnerror(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSRTCDataChannelOnerror(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsRTCDataChannelOnclose(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSRTCDataChannelOnclose(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsRTCDataChannelOnmessage(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSRTCDataChannelOnmessage(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)

#endif
