/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSpeechSynthesisUtterance_h
#define JSSpeechSynthesisUtterance_h

#if ENABLE(SPEECH_SYNTHESIS)

#include "JSDOMBinding.h"
#include "SpeechSynthesisUtterance.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class JSSpeechSynthesisUtterance : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSSpeechSynthesisUtterance* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SpeechSynthesisUtterance> impl)
    {
        JSSpeechSynthesisUtterance* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisUtterance>(globalObject->vm().heap)) JSSpeechSynthesisUtterance(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static void put(JSC::JSCell*, JSC::ExecState*, JSC::PropertyName, JSC::JSValue, JSC::PutPropertySlot&);
    static void destroy(JSC::JSCell*);
    ~JSSpeechSynthesisUtterance();
    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);

    SpeechSynthesisUtterance& impl() const { return *m_impl; }
    void releaseImpl() { m_impl->deref(); m_impl = 0; }

    void releaseImplIfNotNull()
    {
        if (m_impl) {
            m_impl->deref();
            m_impl = 0;
        }
    }

private:
    SpeechSynthesisUtterance* m_impl;
protected:
    JSSpeechSynthesisUtterance(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<SpeechSynthesisUtterance>);
    void finishCreation(JSC::VM&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::InterceptsGetOwnPropertySlotByIndexEvenWhenLengthIsNotZero | JSC::OverridesVisitChildren | Base::StructureFlags;
};

class JSSpeechSynthesisUtteranceOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, SpeechSynthesisUtterance*)
{
    DEFINE_STATIC_LOCAL(JSSpeechSynthesisUtteranceOwner, jsSpeechSynthesisUtteranceOwner, ());
    return &jsSpeechSynthesisUtteranceOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, SpeechSynthesisUtterance*)
{
    return &world;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, SpeechSynthesisUtterance*);
SpeechSynthesisUtterance* toSpeechSynthesisUtterance(JSC::JSValue);

class JSSpeechSynthesisUtterancePrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::VM&, JSC::JSGlobalObject*);
    static JSSpeechSynthesisUtterancePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSpeechSynthesisUtterancePrototype* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisUtterancePrototype>(vm.heap)) JSSpeechSynthesisUtterancePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSpeechSynthesisUtterancePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(vm, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesVisitChildren | Base::StructureFlags;
};

class JSSpeechSynthesisUtteranceConstructor : public DOMConstructorObject {
private:
    JSSpeechSynthesisUtteranceConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSSpeechSynthesisUtteranceConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSSpeechSynthesisUtteranceConstructor* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisUtteranceConstructor>(vm.heap)) JSSpeechSynthesisUtteranceConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::ImplementsHasInstance | DOMConstructorObject::StructureFlags;
    static JSC::EncodedJSValue JSC_HOST_CALL constructJSSpeechSynthesisUtterance(JSC::ExecState*);
    static JSC::ConstructType getConstructData(JSC::JSCell*, JSC::ConstructData&);
};

// Attributes

JSC::JSValue jsSpeechSynthesisUtteranceText(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceText(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceLang(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceLang(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceVoice(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceVoice(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceVolume(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceVolume(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceRate(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceRate(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtterancePitch(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtterancePitch(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnstart(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnstart(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnend(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnend(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnerror(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnerror(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnpause(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnpause(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnresume(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnresume(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnmark(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnmark(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceOnboundary(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
void setJSSpeechSynthesisUtteranceOnboundary(JSC::ExecState*, JSC::JSObject*, JSC::JSValue);
JSC::JSValue jsSpeechSynthesisUtteranceConstructor(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);

} // namespace WebCore

#endif // ENABLE(SPEECH_SYNTHESIS)

#endif
