/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSpeechSynthesisVoice_h
#define JSSpeechSynthesisVoice_h

#if ENABLE(SPEECH_SYNTHESIS)

#include "JSDOMBinding.h"
#include "SpeechSynthesisVoice.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class JSSpeechSynthesisVoice : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSSpeechSynthesisVoice* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SpeechSynthesisVoice> impl)
    {
        JSSpeechSynthesisVoice* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisVoice>(globalObject->vm().heap)) JSSpeechSynthesisVoice(structure, globalObject, impl);
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static void destroy(JSC::JSCell*);
    ~JSSpeechSynthesisVoice();
    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    SpeechSynthesisVoice& impl() const { return *m_impl; }
    void releaseImpl() { m_impl->deref(); m_impl = 0; }

    void releaseImplIfNotNull()
    {
        if (m_impl) {
            m_impl->deref();
            m_impl = 0;
        }
    }

private:
    SpeechSynthesisVoice* m_impl;
protected:
    JSSpeechSynthesisVoice(JSC::Structure*, JSDOMGlobalObject*, PassRefPtr<SpeechSynthesisVoice>);
    void finishCreation(JSC::VM&);
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | JSC::InterceptsGetOwnPropertySlotByIndexEvenWhenLengthIsNotZero | Base::StructureFlags;
};

class JSSpeechSynthesisVoiceOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, SpeechSynthesisVoice*)
{
    DEFINE_STATIC_LOCAL(JSSpeechSynthesisVoiceOwner, jsSpeechSynthesisVoiceOwner, ());
    return &jsSpeechSynthesisVoiceOwner;
}

inline void* wrapperContext(DOMWrapperWorld& world, SpeechSynthesisVoice*)
{
    return &world;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, SpeechSynthesisVoice*);
SpeechSynthesisVoice* toSpeechSynthesisVoice(JSC::JSValue);

class JSSpeechSynthesisVoicePrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSC::JSObject* self(JSC::VM&, JSC::JSGlobalObject*);
    static JSSpeechSynthesisVoicePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSpeechSynthesisVoicePrototype* ptr = new (NotNull, JSC::allocateCell<JSSpeechSynthesisVoicePrototype>(vm.heap)) JSSpeechSynthesisVoicePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSpeechSynthesisVoicePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure) : JSC::JSNonFinalObject(vm, structure) { }
protected:
    static const unsigned StructureFlags = Base::StructureFlags;
};

// Attributes

JSC::JSValue jsSpeechSynthesisVoiceVoiceURI(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsSpeechSynthesisVoiceName(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsSpeechSynthesisVoiceLang(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsSpeechSynthesisVoiceLocalService(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);
JSC::JSValue jsSpeechSynthesisVoiceDefault(JSC::ExecState*, JSC::JSValue, JSC::PropertyName);

} // namespace WebCore

#endif // ENABLE(SPEECH_SYNTHESIS)

#endif
