/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(INDIE_UI)

#include "JSUIRequestEvent.h"

#include "EventTarget.h"
#include "JSDictionary.h"
#include "JSEventTarget.h"
#include "UIRequestEvent.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSUIRequestEventTableValues[] =
{
    { "receiver", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsUIRequestEventReceiver), (intptr_t)0 },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsUIRequestEventConstructor), (intptr_t)0 },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSUIRequestEventTable = { 5, 3, JSUIRequestEventTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSUIRequestEventConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSUIRequestEventConstructorTable = { 1, 0, JSUIRequestEventConstructorTableValues, 0 };
EncodedJSValue JSC_HOST_CALL JSUIRequestEventConstructor::constructJSUIRequestEvent(ExecState* exec)
{
    JSUIRequestEventConstructor* jsConstructor = jsCast<JSUIRequestEventConstructor*>(exec->callee());

    ScriptExecutionContext* executionContext = jsConstructor->scriptExecutionContext();
    if (!executionContext)
        return throwVMError(exec, createReferenceError(exec, "Constructor associated execution context is unavailable"));

    AtomicString eventType = exec->argument(0).toString(exec)->value(exec);
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    UIRequestEventInit eventInit;

    JSValue initializerValue = exec->argument(1);
    if (!initializerValue.isUndefinedOrNull()) {
        // Given the above test, this will always yield an object.
        JSObject* initializerObject = initializerValue.toObject(exec);

        // Create the dictionary wrapper from the initializer object.
        JSDictionary dictionary(exec, initializerObject);

        // Attempt to fill in the EventInit.
        if (!fillUIRequestEventInit(eventInit, dictionary))
            return JSValue::encode(jsUndefined());
    }

    RefPtr<UIRequestEvent> event = UIRequestEvent::create(eventType, eventInit);
    return JSValue::encode(toJS(exec, jsConstructor->globalObject(), event.get()));
}

bool fillUIRequestEventInit(UIRequestEventInit& eventInit, JSDictionary& dictionary)
{
    if (!fillUIEventInit(eventInit, dictionary))
        return false;

    return true;
}

const ClassInfo JSUIRequestEventConstructor::s_info = { "UIRequestEventConstructor", &Base::s_info, &JSUIRequestEventConstructorTable, 0, CREATE_METHOD_TABLE(JSUIRequestEventConstructor) };

JSUIRequestEventConstructor::JSUIRequestEventConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSUIRequestEventConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSUIRequestEventPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontDelete | DontEnum);
}

bool JSUIRequestEventConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSUIRequestEventConstructor, JSDOMWrapper>(exec, JSUIRequestEventConstructorTable, jsCast<JSUIRequestEventConstructor*>(object), propertyName, slot);
}

ConstructType JSUIRequestEventConstructor::getConstructData(JSCell*, ConstructData& constructData)
{
    constructData.native.function = constructJSUIRequestEvent;
    return ConstructTypeHost;
}

/* Hash table for prototype */

static const HashTableValue JSUIRequestEventPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSUIRequestEventPrototypeTable = { 1, 0, JSUIRequestEventPrototypeTableValues, 0 };
const ClassInfo JSUIRequestEventPrototype::s_info = { "UIRequestEventPrototype", &Base::s_info, &JSUIRequestEventPrototypeTable, 0, CREATE_METHOD_TABLE(JSUIRequestEventPrototype) };

JSObject* JSUIRequestEventPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSUIRequestEvent>(vm, globalObject);
}

const ClassInfo JSUIRequestEvent::s_info = { "UIRequestEvent", &Base::s_info, &JSUIRequestEventTable, 0 , CREATE_METHOD_TABLE(JSUIRequestEvent) };

JSUIRequestEvent::JSUIRequestEvent(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<UIRequestEvent> impl)
    : JSUIEvent(structure, globalObject, impl)
{
}

void JSUIRequestEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSUIRequestEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSUIRequestEventPrototype::create(vm, globalObject, JSUIRequestEventPrototype::createStructure(vm, globalObject, JSUIEventPrototype::self(vm, globalObject)));
}

bool JSUIRequestEvent::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSUIRequestEvent* thisObject = jsCast<JSUIRequestEvent*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSUIRequestEvent, Base>(exec, JSUIRequestEventTable, thisObject, propertyName, slot);
}

JSValue jsUIRequestEventReceiver(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSUIRequestEvent* castedThis = jsCast<JSUIRequestEvent*>(asObject(slotBase));
    UNUSED_PARAM(exec);
    UIRequestEvent& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.receiver()));
    return result;
}


JSValue jsUIRequestEventConstructor(ExecState* exec, JSValue slotBase, PropertyName)
{
    JSUIRequestEvent* domObject = jsCast<JSUIRequestEvent*>(asObject(slotBase));
    return JSUIRequestEvent::getConstructor(exec->vm(), domObject->globalObject());
}

JSValue JSUIRequestEvent::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSUIRequestEventConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}

#endif // ENABLE(INDIE_UI)
